gi-gio-2.0.27: Gio bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gio.Objects.Cancellable

Contents

- Exported types
- Methods
  - Overloaded methods
  - cancel
  - connect
  - disconnect
  - getCurrent
  - getFd
  - isCancelled
  - makePollfd
  - new
  - popCurrent
  - pushCurrent
  - releaseFd
  - reset
  - setErrorIfCancelled
  - sourceNew
- Signals
  - cancelled

Description

GCancellable is a thread-safe operation cancellation stack used throughout GIO to allow for cancellation of synchronous and asynchronous operations.

Synopsis

- newtype Cancellable = Cancellable (ManagedPtr Cancellable)
- class (GObject o, IsDescendantOf Cancellable o) => IsCancellable o
- toCancellable :: (MonadIO m, IsCancellable o) => o -> m Cancellable
- cancellableCancel :: (HasCallStack, MonadIO m, IsCancellable a) => a -> m ()
- cancellableConnect :: (HasCallStack, MonadIO m, IsCancellable a) => a -> Callback -> m CULong
- cancellableDisconnect :: (HasCallStack, MonadIO m, IsCancellable a) => a -> CULong -> m ()
- cancellableGetCurrent :: (HasCallStack, MonadIO m) => m (Maybe Cancellable)
- cancellableGetFd :: (HasCallStack, MonadIO m, IsCancellable a) => a -> m Int32
- cancellableIsCancelled :: (HasCallStack, MonadIO m, IsCancellable a) => a -> m Bool
- cancellableMakePollfd :: (HasCallStack, MonadIO m, IsCancellable a) => a -> PollFD -> m Bool
- cancellableNew :: (HasCallStack, MonadIO m) => m Cancellable
- cancellablePopCurrent :: (HasCallStack, MonadIO m, IsCancellable a) => a -> m ()
- cancellablePushCurrent :: (HasCallStack, MonadIO m, IsCancellable a) => a -> m ()
- cancellableReleaseFd :: (HasCallStack, MonadIO m, IsCancellable a) => a -> m ()
- cancellableReset :: (HasCallStack, MonadIO m, IsCancellable a) => a -> m ()
- cancellableSetErrorIfCancelled :: (HasCallStack, MonadIO m, IsCancellable a) => a -> m ()
- cancellableSourceNew :: (HasCallStack, MonadIO m, IsCancellable a) => a -> m Source
- type C_CancellableCancelledCallback = Ptr () -> Ptr () -> IO ()
- type CancellableCancelledCallback = IO ()
- afterCancellableCancelled :: (IsCancellable a, MonadIO m) => a -> CancellableCancelledCallback -> m SignalHandlerId
- genClosure_CancellableCancelled :: MonadIO m => CancellableCancelledCallback -> m (GClosure C_CancellableCancelledCallback)
- mk_CancellableCancelledCallback :: C_CancellableCancelledCallback -> IO (FunPtr C_CancellableCancelledCallback)
- noCancellableCancelledCallback :: Maybe CancellableCancelledCallback
- onCancellableCancelled :: (IsCancellable a, MonadIO m) => a -> CancellableCancelledCallback -> m SignalHandlerId
- wrap_CancellableCancelledCallback :: CancellableCancelledCallback -> C_CancellableCancelledCallback

# Exported types

newtype Cancellable Source #

Memory-managed wrapper type.

Constructors

Cancellable (ManagedPtr Cancellable) |

#### Instances

Instances details

Eq Cancellable Source # |
Instance details Defined in GI.Gio.Objects.Cancellable Methods (==) :: Cancellable -> Cancellable -> Bool # (/=) :: Cancellable -> Cancellable -> Bool #
GObject Cancellable Source # |
Instance details Defined in GI.Gio.Objects.Cancellable
TypedObject Cancellable Source # |
Instance details Defined in GI.Gio.Objects.Cancellable Methods glibType :: IO GType Source #
ManagedPtrNewtype Cancellable Source # |
Instance details Defined in GI.Gio.Objects.Cancellable Methods toManagedPtr :: Cancellable -> ManagedPtr Cancellable Source #
IsGValue Cancellable Source # | Convert `Cancellable` to and from `GValue` with `toGValue` and `fromGValue`.
Instance details Defined in GI.Gio.Objects.Cancellable Methods toGValue :: Cancellable -> IO GValue Source # fromGValue :: GValue -> IO Cancellable Source #
HasParentTypes Cancellable Source # |
Instance details Defined in GI.Gio.Objects.Cancellable
type ParentTypes Cancellable Source # |
Instance details Defined in GI.Gio.Objects.Cancellable type ParentTypes Cancellable = '[Object]

class (GObject o, IsDescendantOf Cancellable o) => IsCancellable o Source #

Type class for types which can be safely cast to `Cancellable`, for instance with `toCancellable`.

#### Instances

Instances details

(GObject o, IsDescendantOf Cancellable o) => IsCancellable o Source # |
Instance details Defined in GI.Gio.Objects.Cancellable

toCancellable :: (MonadIO m, IsCancellable o) => o -> m Cancellable Source #

Cast to `Cancellable`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

## Overloaded methods

## cancel

cancellableCancel Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: a `Cancellable` object.
-> m () |

Will set `cancellable` to cancelled, and will emit the cancelled signal. (However, see the warning about race conditions in the documentation for that signal if you are planning to connect to it.)

This function is thread-safe. In other words, you can safely call it from a thread other than the one running the operation that was passed the `cancellable`.

If `cancellable` is `Nothing`, this function returns immediately for convenience.

The convention within GIO is that cancelling an asynchronous operation causes it to complete asynchronously. That is, if you cancel the operation from the same thread in which it is running, then the operation's `AsyncReadyCallback` will not be invoked until the application returns to the main loop.

## connect

cancellableConnect Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: A `Cancellable`.
-> Callback | `callback`: The `Callback` to connect.
-> m CULong | Returns: The id of the signal handler or 0 if `cancellable` has already been cancelled.

Convenience function to connect to the cancelled signal. Also handles the race condition that may happen if the cancellable is cancelled right before connecting.

`callback` is called at most once, either directly at the time of the connect if `cancellable` is already cancelled, or when `cancellable` is cancelled in some thread.

`dataDestroyFunc` will be called when the handler is disconnected, or immediately if the cancellable is already cancelled.

See cancelled for details on how to use this.

Since GLib 2.40, the lock protecting `cancellable` is not held when `callback` is invoked. This lifts a restriction in place for earlier GLib versions which now makes it easier to write cleanup code that unconditionally invokes e.g. `cancellableCancel`.

Since: 2.22

## disconnect

cancellableDisconnect Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: A `Cancellable` or `Nothing`.
-> CULong | `handlerId`: Handler id of the handler to be disconnected, or `0`.
-> m () |

Disconnects a handler from a cancellable instance similar to `signalHandlerDisconnect`. Additionally, in the event that a signal handler is currently running, this call will block until the handler has finished. Calling this function from a cancelled signal handler will therefore result in a deadlock.

This avoids a race condition where a thread cancels at the same time as the cancellable operation is finished and the signal handler is removed. See cancelled for details on how to use this.

If `cancellable` is `Nothing` or `handlerId` is `0` this function does nothing.

Since: 2.22

## getCurrent

cancellableGetCurrent Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m (Maybe Cancellable) | Returns: a `Cancellable` from the top of the stack, or `Nothing` if the stack is empty.

Gets the top cancellable from the stack.

## getFd

cancellableGetFd Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: a `Cancellable`.
-> m Int32 | Returns: A valid file descriptor. `-1` if the file descriptor is not supported, or on errors.

Gets the file descriptor for a cancellable job. This can be used to implement cancellable operations on Unix systems. The returned fd will turn readable when `cancellable` is cancelled.

You are not supposed to read from the fd yourself, just check for readable status. Reading to unset the readable status is done with `cancellableReset`.

After a successful return from this function, you should use `cancellableReleaseFd` to free up resources allocated for the returned file descriptor.

See also `cancellableMakePollfd`.

## isCancelled

cancellableIsCancelled Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: a `Cancellable` or `Nothing`
-> m Bool | Returns: `True` if `cancellable` is cancelled, FALSE if called with `Nothing` or if item is not cancelled.

Checks if a cancellable job has been cancelled.

## makePollfd

cancellableMakePollfd Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: a `Cancellable` or `Nothing`
-> PollFD | `pollfd`: a pointer to a `PollFD`
-> m Bool | Returns: `True` if `pollfd` was successfully initialized, `False` on failure to prepare the cancellable.

Creates a `PollFD` corresponding to `cancellable`; this can be passed to `poll` and used to poll for cancellation. This is useful both for unix systems without a native poll and for portability to windows.

When this function returns `True`, you should use `cancellableReleaseFd` to free up resources allocated for the `pollfd`. After a `False` return, do not call `cancellableReleaseFd`.

If this function returns `False`, either no `cancellable` was given or resource limits prevent this function from allocating the necessary structures for polling. (On Linux, you will likely have reached the maximum number of file descriptors.) The suggested way to handle these cases is to ignore the `cancellable`.

You are not supposed to read from the fd yourself, just check for readable status. Reading to unset the readable status is done with `cancellableReset`.

Since: 2.22

## new

cancellableNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m Cancellable | Returns: a `Cancellable`.

Creates a new `Cancellable` object.

Applications that want to start one or more operations that should be cancellable should create a `Cancellable` and pass it to the operations.

One `Cancellable` can be used in multiple consecutive operations or in multiple concurrent operations.

## popCurrent

cancellablePopCurrent Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: a `Cancellable` object
-> m () |

Pops `cancellable` off the cancellable stack (verifying that `cancellable` is on the top of the stack).

## pushCurrent

cancellablePushCurrent Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: a `Cancellable` object
-> m () |

Pushes `cancellable` onto the cancellable stack. The current cancellable can then be received using `cancellableGetCurrent`.

This is useful when implementing cancellable operations in code that does not allow you to pass down the cancellable object.

This is typically called automatically by e.g. `File` operations, so you rarely have to call this yourself.

## releaseFd

cancellableReleaseFd Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: a `Cancellable`
-> m () |

Releases a resources previously allocated by `cancellableGetFd` or `cancellableMakePollfd`.

For compatibility reasons with older releases, calling this function is not strictly required, the resources will be automatically freed when the `cancellable` is finalized. However, the `cancellable` will block scarce file descriptors until it is finalized if this function is not called. This can cause the application to run out of file descriptors when many `GCancellables` are used at the same time.

Since: 2.22

## reset

cancellableReset Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: a `Cancellable` object.
-> m () |

Resets `cancellable` to its uncancelled state.

If cancellable is currently in use by any cancellable operation then the behavior of this function is undefined.

Note that it is generally not a good idea to reuse an existing cancellable for more operations after it has been cancelled once, as this function might tempt you to do. The recommended practice is to drop the reference to a cancellable after cancelling it, and let it die with the outstanding async operations. You should create a fresh cancellable for further async operations.

## setErrorIfCancelled

cancellableSetErrorIfCancelled Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: a `Cancellable` or `Nothing`
-> m () | (Can throw `GError`)

If the `cancellable` is cancelled, sets the error to notify that the operation was cancelled.

## sourceNew

cancellableSourceNew Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> a | `cancellable`: a `Cancellable`, or `Nothing`
-> m Source | Returns: the new `Source`.

Creates a source that triggers if `cancellable` is cancelled and calls its callback of type `CancellableSourceFunc`. This is primarily useful for attaching to another (non-cancellable) source with `sourceAddChildSource` to add cancellability to it.

For convenience, you can call this with a `Nothing` `Cancellable`, in which case the source will never trigger.

The new `Source` will hold a reference to the `Cancellable`.

Since: 2.28

# Signals

## cancelled

type C_CancellableCancelledCallback = Ptr () -> Ptr () -> IO () Source #

Type for the callback on the (unwrapped) C side.

type CancellableCancelledCallback = IO () Source #

Emitted when the operation has been cancelled.

Can be used by implementations of cancellable operations. If the operation is cancelled from another thread, the signal will be emitted in the thread that cancelled the operation, not the thread that is running the operation.

Note that disconnecting from this signal (or any signal) in a multi-threaded program is prone to race conditions. For instance it is possible that a signal handler may be invoked even after a call to `signalHandlerDisconnect` for that handler has already returned.

There is also a problem when cancellation happens right before connecting to the signal. If this happens the signal will unexpectedly not be emitted, and checking before connecting to the signal leaves a race condition where this is still happening.

In order to make it safe and easy to connect handlers there are two helper functions: `cancellableConnect` and `cancellableDisconnect` which protect against problems like this.

An example of how to us this:

### C code

       // Make sure we don't do unnecessary work if already cancelled
       if (g_cancellable_set_error_if_cancelled (cancellable, error))
         return;

       // Set up all the data needed to be able to handle cancellation
       // of the operation
       my_data = my_data_new (...);

       id = 0;
       if (cancellable)
         id = g_cancellable_connect (cancellable,
       			      G_CALLBACK (cancelled_handler)
       			      data, NULL);

       // cancellable operation here...

       g_cancellable_disconnect (cancellable, id);

       // cancelled_handler is never called after this, it is now safe
       // to free the data
       my_data_free (my_data);

Note that the cancelled signal is emitted in the thread that the user cancelled from, which may be the main thread. So, the cancellable signal should not do something that can block.

afterCancellableCancelled :: (IsCancellable a, MonadIO m) => a -> CancellableCancelledCallback -> m SignalHandlerId Source #

Connect a signal handler for the cancelled signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after cancellable #cancelled callback

genClosure_CancellableCancelled :: MonadIO m => CancellableCancelledCallback -> m (GClosure C_CancellableCancelledCallback) Source #

Wrap the callback into a `GClosure`.

mk_CancellableCancelledCallback :: C_CancellableCancelledCallback -> IO (FunPtr C_CancellableCancelledCallback) Source #

Generate a function pointer callable from C code, from a `C_CancellableCancelledCallback`.

noCancellableCancelledCallback :: Maybe CancellableCancelledCallback Source #

A convenience synonym for ``Nothing` :: `Maybe` `CancellableCancelledCallback``.

onCancellableCancelled :: (IsCancellable a, MonadIO m) => a -> CancellableCancelledCallback -> m SignalHandlerId Source #

Connect a signal handler for the cancelled signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on cancellable #cancelled callback

wrap_CancellableCancelledCallback :: CancellableCancelledCallback -> C_CancellableCancelledCallback Source #

Wrap a `CancellableCancelledCallback` into a `C_CancellableCancelledCallback`.